{"openapi":"3.1.0","info":{"title":"3Commas Public API (unofficial)","description":"This file is an updated OpenAPI file for 3Commas, that tries to be as close as possible to 3Commas official API (current state: 2023-04-04). <p/> Even though most of the endpoint descriptions should already work, this file is still work in progress. <p/> To use the OpenAPI file in other tools or just to download it use the following <a href=\"httpssi://api.swaggerhub.com/apis/d_yo_r/3commas_openapidoc.yml/0.0.1\"> address of the definition itself</a> without the additional context of this homepage. <p/> To generate client and server code from that file visit the correstionding <a href=\"https://app.swaggerhub.com/apis/d_yo_r/3commas_openapidoc.yml/0.0.1\"> 3Commas Public API (unofficial) at SwaggerHub</a>. <p/> To use this file, you have to generate a signature for most of the endpoints. You can use <a href=\"https://sites.google.com/view/tiny-trading-toolbox/welcome/api/3commas/signature-calculator\"> my signature calculator</a> to do so. Check its code if you like, too. <p/> There's still some work to do to check whether all endpoints are fully functional. Further, missing response bodies have to be added, the file has to be modularized more, further type schemas should be added, ... You can find most of the TODO's by searching for TODO. Or check the <a href=\"https://ratemyopenapi.com/report/b7b22c65-74c1-45c2-a0a0-94e957ca3bb4\">report of Rate My OpenAPI</a>.\n<h2>Disclaimer</h2> <p/> <b><i>Use at your own risk.</i></b>\n<h2>Security advice</h2> <p/> Never ever publish your <i>webhook's email_token</i>, since it is unchangeable for you and valid for your whole 3Commas account. <b><i>Please, else directly contact 3Commas' support to reset it.</i></b> <p/> Also never ever publish your <i>API secret</i>. <b><i>Please, else directly delete your API key and create a new one.</i></b>\n<h2>Final notes</h2> <p/> In case, you want to help me, to <i>improve this file</i>, feel free to contact me at Telegram @d_yo_r.\n<p/> And please, always do your own research!\n","contact":{"name":"3Commas Public API","url":"https://github.com/3commas-io/3commas-official-api-docs"},"version":"0.0.1-oas3.1"},"servers":[{"url":"https://api.3commas.io/public/api","description":"API server"}],"tags":[{"name":"ping","description":"Test connectivity"},{"name":"time","description":"Get 3Commas' server time"},{"name":"general_validate","description":"Validating API credentials"},{"name":"mini_apps","description":"Operations about mini_apps"},{"name":"users","description":"Operations about users"},{"name":"portfolios","description":"Operations about portfolios"},{"name":"loose_accounts","description":"Operations about loose_accounts"},{"name":"accounts","description":"Operations about accounts"},{"name":"bots","description":"Operations about bots"},{"name":"deals","description":"Operations about deals"},{"name":"smart_trades_v2","description":"Operations about smart_trades_v2s"},{"name":"grid_bots","description":"Operations about grid_bots"},{"name":"marketplace","description":"Operations about marketplaces"},{"name":"webhooks","description":"Operations about webhooks"},{"name":"streams","description":"Operations about streams. <p/> Be aware, that this probably is not functional and currently could only be defined using <a href='https://www.asyncapi.com/'>Async API</a>. In a later version of OpenAPI it may be possible to do it with that as well.\n"}],"paths":{"/ver1/ping":{"get":{"security":[],"tags":["ping"],"description":"Test connectivity to the Rest API (Permission: NONE, Security: NONE)\n","operationId":"getVer1Ping","responses":{"200":{"$ref":"#/components/responses/PingResponse"}}}},"/ver1/time":{"get":{"security":[],"tags":["time"],"description":"Test connectivity to the Rest API and get the current server time (Permission: NONE, Security: NONE)\n","operationId":"getVer1Time","responses":{"200":{"$ref":"#/components/responses/TimeResponse"}}}},"/ver1/validate":{"get":{"tags":["general_validate"],"description":"Api credentials validity check (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1Validate","responses":{"200":{"$ref":"#/components/responses/ValidateResponse"},"401":{"description":"Provided signature is invalid","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/mini_apps/credentials":{"get":{"security":[],"tags":["mini_apps"],"description":"Fetch API credentials by token\n","operationId":"getVer1MiniAppsCredentials","parameters":[{"$ref":"#/components/parameters/miniAppsTokenParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"},"404":{"description":"Not Found","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/mini_apps/storage":{"get":{"tags":["mini_apps"],"description":"Fetch data from storage (Security: SIGNED)\n","operationId":"getVer1MiniAppsStorage","parameters":[{"$ref":"#/components/parameters/miniAppsKeyParam"}],"responses":{"200":{"$ref":"#/components/responses/StorageResponse"},"403":{"description":"Api key must be created by Mini App","$ref":"#/components/responses/ErrorResponse"}}},"post":{"tags":["mini_apps"],"description":"Write data into storage (Security: SIGNED)\n","operationId":"postVer1MiniAppsStorage","requestBody":{"$ref":"#/components/requestBodies/StorageRequest"},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"},"201":{"$ref":"#/components/responses/TodoResponse"},"403":{"description":"Api key must be created by Mini App","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/users/locale":{"put":{"tags":["users"],"description":"Change user locale (Security: SIGNED)\n","operationId":"putVer1UsersLocale","requestBody":{"$ref":"#/components/requestBodies/LocaleRequest"},"responses":{"200":{"$ref":"#/components/responses/BooleanResponse"}}}},"/ver1/users/permissions_info":{"get":{"tags":["users"],"description":"Api Key Permissions (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1UsersPermissionsInfo","responses":{"200":{"$ref":"#/components/responses/UserPermissionResponse"}}}},"/ver1/users/current_mode":{"get":{"tags":["users"],"description":"Current User Mode (Paper or Real) (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1UsersCurrentMode","responses":{"200":{"$ref":"#/components/responses/UserCurrentModeResponse"}}}},"/ver1/users/change_mode":{"post":{"tags":["users"],"description":"Change User Mode (Paper or Real) (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1UsersChangeMode","requestBody":{"$ref":"#/components/requestBodies/UserChangeModeRequest"},"responses":{"201":{"$ref":"#/components/responses/BooleanResponse"}}}},"/ver1/portfolios":{"get":{"tags":["portfolios"],"description":"Show portfolios list (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1Portfolios","parameters":[{"$ref":"#/components/parameters/pageParam"},{"$ref":"#/components/parameters/perPageParam"}],"responses":{"200":{"$ref":"#/components/responses/PortfoliosResponse"}}}},"/ver1/portfolios/{portfolio_id}":{"get":{"tags":["portfolios"],"description":"Show portfolio info (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1PortfoliosId","parameters":[{"$ref":"#/components/parameters/portfolioIdParam"}],"responses":{"200":{"$ref":"#/components/responses/PortfolioResponse"}}}},"/ver1/loose_accounts":{"post":{"tags":["loose_accounts"],"description":"Create Loose Account (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1LooseAccounts","requestBody":{"$ref":"#/components/requestBodies/LooseAccountsCreateRequest"},"responses":{"201":{"$ref":"#/components/responses/LooseAccountResponse"}}}},"/ver1/loose_accounts/available_currencies":{"get":{"tags":["loose_accounts"],"description":"Available currencies (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1LooseAccountsAvailableCurrencies","parameters":[{"$ref":"#/components/parameters/containsParam"},{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"}],"responses":{"200":{"$ref":"#/components/responses/LooseAccountsAvailableCurrenciesResponse"}}}},"/ver1/loose_accounts/{account_id}":{"put":{"tags":["loose_accounts"],"description":"Update Loose Account (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"putVer1LooseAccountsAccountId","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/LooseAccountsUpdateRequest"},"responses":{"200":{"$ref":"#/components/responses/LooseAccountResponse"},"401":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/market_list":{"get":{"tags":["accounts"],"description":"Supported markets list (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getVer1AccountsMarketList","responses":{"200":{"$ref":"#/components/responses/MarketListResponse"}}}},"/ver1/accounts/market_pairs":{"get":{"tags":["accounts"],"description":"All market pairs (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getVer1AccountsMarketPairs","parameters":[{"$ref":"#/components/parameters/marketCodeParam"}],"responses":{"200":{"$ref":"#/components/responses/MarketPairsResponse"}}}},"/v2/accounts/market_pairs":{"get":{"tags":["accounts"],"description":"All market pairs (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getV2AccountsMarketPairs","parameters":[{"$ref":"#/components/parameters/marketCodeParam"}],"responses":{"200":{"$ref":"#/components/responses/MarketPairsResponse"}}}},"/ver1/accounts/currency_rates":{"get":{"tags":["accounts"],"description":"Currency rates and limits (Permission: NONE, Security: NONE) If you are retrieving data for pairs, you must also include market_code\n","security":[],"operationId":"getVer1AccountsCurrencyRates","parameters":[{"$ref":"#/components/parameters/marketCodeRequiredParam"},{"$ref":"#/components/parameters/pairRequiredParam"},{"$ref":"#/components/parameters/limitTypeParam"}],"responses":{"200":{"$ref":"#/components/responses/CurrencyRatesResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/currency_rates_with_leverage_data":{"get":{"tags":["accounts"],"description":"Currency rates and limits with leverage data (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getVer1AccountsCurrencyRatesWithLeverageData","parameters":[{"$ref":"#/components/parameters/marketCodeRequiredParam"},{"$ref":"#/components/parameters/pairsRequiredParam"}],"responses":{"200":{"$ref":"#/components/responses/CurrencyRatesWithLeverageResponse"}}}},"/ver1/accounts":{"get":{"tags":["accounts"],"description":"User connected exchanges (and EthereumWallet) list (Permission: ACCOUNTS_READ, Security: SIGNED) +\n","operationId":"getVer1Accounts","parameters":[{"$ref":"#/components/parameters/apiKeyParam"},{"$ref":"#/components/parameters/pageParam"},{"$ref":"#/components/parameters/perPageParam"}],"responses":{"200":{"$ref":"#/components/responses/AccountsResponse"},"401":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/types_to_connect":{"get":{"tags":["accounts"],"description":"Available market subtypes to connect\n","operationId":"getVer1AccountsTypesToConnect","parameters":[{"$ref":"#/components/parameters/marketTypeParam"},{"$ref":"#/components/parameters/nameParam"},{"$ref":"#/components/parameters/apiKeyParam"},{"$ref":"#/components/parameters/secretParam"}],"responses":{"200":{"$ref":"#/components/responses/TypesToConnectResponse"},"422":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/new":{"post":{"tags":["accounts"],"description":"Add exchange account  (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsNew","requestBody":{"$ref":"#/components/requestBodies/AccountsCreateRequest"},"responses":{"201":{"$ref":"#/components/responses/AccountsNewResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/update":{"post":{"tags":["accounts"],"description":"Edit exchange account","operationId":"postVer1AccountsUpdate","requestBody":{"$ref":"#/components/requestBodies/AccountsUpdateRequest"},"responses":{"201":{"$ref":"#/components/responses/AccountsUpdateResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/{account_id}/load_balances":{"post":{"tags":["accounts"],"description":"Load balances for specified exchange  (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdLoadBalances","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"$ref":"#/components/responses/AccountResponse"}}}},"/ver1/accounts/{account_id}":{"get":{"tags":["accounts"],"description":"Single Account Info (Permission: ACCOUNTS_READ, Security: SIGNED)\nYou can send 'summary' instead of {account_id} to get summary account info\n","operationId":"getVer1AccountsAccountId","parameters":[{"$ref":"#/components/parameters/accountIdOrSummaryRequiredPathParam"}],"responses":{"200":{"$ref":"#/components/responses/AccountResponse"}}}},"/ver1/accounts/{account_id}/rename":{"post":{"tags":["accounts"],"description":"Rename exchange connection  (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdRename","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/AccountRenameRequest"},"responses":{"201":{"$ref":"#/components/responses/AccountResponse"}}}},"/ver1/accounts/{account_id}/remove":{"post":{"tags":["accounts"],"description":"Remove exchange connection  (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdRemove","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"$ref":"#/components/responses/BooleanResponse"}}}},"/ver1/accounts/{account_id}/active_trading_entities":{"get":{"tags":["accounts"],"description":"Active trade entities (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsAccountIdActiveTradingEntities","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"200":{"$ref":"#/components/responses/AccountActiveTradingEntitiesResponse"}}}},"/ver1/accounts/{account_id}/networks_info":{"get":{"tags":["accounts"],"description":"Deposit/withdraw networks info (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsAccountIdNetworksInfo","parameters":[{"$ref":"#/components/parameters/accountIdParam"},{"$ref":"#/components/parameters/depositWithdrawParam"}],"responses":{"200":{"$ref":"#/components/responses/AccountNetworksInfoResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/transfer_data":{"get":{"tags":["accounts"],"description":"Data for transfer between accounts (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsTransferData","responses":{"200":{"$ref":"#/components/responses/TodoResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/transfer":{"post":{"tags":["accounts"],"description":"Transfer coins between accounts (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsTransfer","requestBody":{"$ref":"#/components/requestBodies/AccountsTransferRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/transfer_history":{"get":{"tags":["accounts"],"description":"Transfers history (Permission:d ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsTransferHistory","parameters":[{"$ref":"#/components/parameters/accountIdTransferQueryRequiredParam"},{"$ref":"#/components/parameters/currencyRequiredParam"},{"$ref":"#/components/parameters/startTimeParam"},{"$ref":"#/components/parameters/pageParam"},{"$ref":"#/components/parameters/perPageParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/accounts/{account_id}/deposit_data":{"get":{"tags":["accounts"],"description":"User Deposit Data (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsAccountIdDepositData","parameters":[{"$ref":"#/components/parameters/accountIdParam"},{"$ref":"#/components/parameters/currencyRequiredParam"},{"$ref":"#/components/parameters/networkRequiredParam"}],"responses":{"200":{"description":"Deposit data response","content":{"application/json":{"schema":{"description":"Deposit data","properties":{"address":{"type":"string","examples":["abcdefghijklmnopqrstuvwxyz12345890"]},"address_tag":{"type":"string","examples":[""]},"qr_image_path":{"type":"string","examples":["/qr/code?code=abcdefghijklmnopqrstuvwxyz12345890"]},"address_tag_qr_path":{"type":"string","examples":["/qr/code?code="]},"available_balance":{"type":"string","format":"double","examples":["12345.12345678"]},"in_orders":{"type":"string","format":"double","examples":["12345.12345678"]},"total_balance":{"type":"string","format":"double","examples":["12345.12345678"]}}}}}}}}},"/ver1/accounts/{account_id}/account_table_data":{"post":{"tags":["accounts"],"description":"Information about all user balances on specified exchange  (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdAccountTableData","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"description":"Account table data response","content":{"application/json":{"schema":{"type":"array","items":{"description":"Account table data","properties":{"currency_code":{"$ref":"#/components/schemas/SymbolStringType"},"currency_name":{"type":"string"},"currency_icon":{"type":"string","format":"url"},"currency_slug":{"$ref":"#/components/schemas/SymbolStringType"},"percentage":{"type":"number","format":"double"},"position":{"type":"number","format":"double"},"position_type":{"type":"number","format":"double"},"borrowed":{"type":"number","format":"double"},"on_orders":{"type":"number","format":"double"},"on_orders_long":{"type":"number","format":"double"},"on_orders_short":{"type":"number","format":"double"},"equity":{"type":"number","format":"double"},"current_price":{"type":"number","format":"double"},"current_price_usd":{"type":"number","format":"double"},"day_change_percent":{"type":"number","format":"double"},"day_change_percent_btc":{"type":"number","format":"double"},"day_change_percent_usd":{"type":"number","format":"double"},"btc_value":{"type":"number","format":"double"},"usd_value":{"type":"number","format":"double"},"available_long":{"type":"number","format":"double"},"available_short":{"type":"number","format":"double"},"available_with_leverage_long":{"type":"number","format":"double"},"available_with_leverage_short":{"type":"number","format":"double"},"account_id":{"type":"number","format":"integer"},"is_wallet":{"type":"boolean"}}}}}}}}}},"/ver1/accounts/{account_id}/balance_chart_data":{"get":{"tags":["accounts"],"description":"balance history data (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsAccountIdBalanceChartData","parameters":[{"$ref":"#/components/parameters/accountIdParam"},{"$ref":"#/components/parameters/dateFilterDateFromRequiredParam"},{"$ref":"#/components/parameters/dateFilterDateToParam"}],"responses":{"200":{"description":"Balance chart data response","content":{"application/json":{"schema":{"type":"array","items":{"description":"Balance chart data","properties":{"date":{"type":"string","format":"date"},"usd":{"type":"number","format":"double"},"btc":{"type":"number","format":"double"},"btc_deposit_amount":{"type":"number","format":"double"},"usd_deposit_amount":{"type":"number","format":"double"}}}}}}}}}},"/ver1/accounts/{account_id}/pie_chart_data":{"post":{"tags":["accounts"],"description":"Information about all user balances on specified exchange in pretty for pie chart format (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdPieChartData","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"description":"Pie chart data response","content":{"application/json":{"schema":{"type":"array","items":{"description":"Balance chart data","properties":{"code":{"type":"string","examples":["EUR"]},"coinmarketcapid":{"type":"string","format":"integer","examples":[825]},"name":{"type":"string","examples":["EUR (EUR)"]},"y":{"type":"number","format":"double","examples":[12.3]},"percentage":{"type":"number","format":"double","examples":[12.3]},"amount":{"type":"number","format":"double","examples":[123.456789]},"btc_value":{"type":"string","format":"double","examples":["1.23456789"]},"usd_value":{"type":"string","format":"double","examples":["1.23456789"]},"primary_display_currency":{"type":"object","properties":{"currency":{"type":"string","examples":["USD"]},"amount":{"type":"string","format":"double","examples":["1234.123412341234123412341234123412341234"]}}},"account_id":{"$ref":"#/components/schemas/AccountIdType"}}}}}}}}}},"/ver1/accounts/{account_id}/leverage_data":{"get":{"tags":["accounts"],"description":"Information about account leverage (Permission: ACCOUNTS_READ, Security: SIGNED)\n","operationId":"getVer1AccountsAccountIdLeverageData","parameters":[{"$ref":"#/components/parameters/accountIdParam"},{"$ref":"#/components/parameters/pairRequiredParam"}],"responses":{"200":{"description":"Leverage data response","content":{"application/json":{"schema":{"type":"array","items":{"description":"Leverage data","properties":{"code":{"type":"string","enum":["cross","isolated"]},"name":{"type":"string","enum":["Cross","Isolated"]},"can_set_leverage_value":{"type":"boolean"},"available_leverage_values":{"type":"array","items":{"description":"TODO"},"properties":{"todo":{"type":"string"}}},"valid":{"description":"Balance chart data","properties":{"min":{"type":"string","format":"double","examples":["1.0"]},"max":{"type":"string","format":"double","examples":["125.0"]}}}}}}}}}}}},"/ver1/accounts/{account_id}/convert_dust_to_bnb":{"post":{"tags":["accounts"],"description":"Convert dust coins to BNB (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdConvertDustToBnb","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/AccountsConvertDustToBnbRequest"},"responses":{"201":{"description":"Sell all to USD response","content":{"application/json":{"schema":{"description":"Sell all to USD","properties":{"totalTransfered":{"type":"string","format":"double","examples":["0.00000001"]},"totalServiceCharge":{"type":"string","format":"integer","examples":["0"]},"transferResult":{"type":"array","items":{"description":"Leverage data","properties":{"tranId":{"type":"integer"},"fromAsset":{"$ref":"#/components/schemas/SymbolStringType"},"amount":{"type":"string","format":"double"},"transferedAmount":{"type":"string","format":"double","examples":["0.00000001"]},"serviceChargeAmount":{"type":"string","format":"integer","examples":["0"]},"operateTime":{"$ref":"#/components/schemas/TimeUnitType"}}}}}}}}},"422":{"description":"Coin not found","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/{account_id}/sell_all_to_usd":{"post":{"tags":["accounts"],"description":"Sell all to USD  (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdSellAllToUsd","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"},"403":{"description":"Forbidden. Unavailable for this account.","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/accounts/{account_id}/sell_all_to_btc":{"post":{"tags":["accounts"],"description":"Sell all to BTC  (Permission: ACCOUNTS_WRITE, Security: SIGNED)\n","operationId":"postVer1AccountsAccountIdSellAllToBtc","parameters":[{"$ref":"#/components/parameters/accountIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"},"403":{"description":"Forbidden. Unavailable for this account.","$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/bots/account_trade_info_smart_sell":{"get":{"tags":["bots"],"description":"Smart Sell Account Table Info (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1BotsAccountTradeInfoSmartSell","parameters":[{"$ref":"#/components/parameters/apiKeyParam"},{"$ref":"#/components/parameters/accountIdQueryRequiredParam"}],"responses":{"200":{"description":"Sell all to USD response","content":{"application/json":{"schema":{"description":"Sell all to USD","properties":{"available_for_sell_balances":{"type":"array","items":{"description":"Symbol (SymbolStringType) - Amount","type":"object","additionalProperties":{"type":"string","format":"double"},"examples":[{"USDT":"0.01","BTC":"0.000000001"}]}},"ticker":{"description":"Current ticker for all pairs of the current exchange's market<p/> Why isn't that a separate endpoint which only returns only the ticker that is currently needed?\n","type":"array","items":{"description":"Pair - Current ticker data","type":"object","additionalProperties":{"type":"object","properties":{"last":{"type":"string","format":"double","examples":["0.066703"]},"bid":{"type":"string","format":"double","examples":["0.066703"]},"ask":{"type":"string","format":"double","examples":["0.066704"]},"name":{"type":"string","examples":["Ethereum"]},"orderbook_ask":{"type":"string","format":"double","examples":["0.066704"]},"orderbook_bid":{"type":"string","format":"double","examples":["0.066703"]},"orderbook_last":{"type":"string","format":"double","examples":["0.066703"]},"orderbook_price_currency":{"$ref":"#/components/schemas/SymbolStringType"},"strategy_name":{"type":"string","examples":["orderbook_price"]},"contract_strategy_name":{"type":"string","examples":["orderbook_price"]},"minPrice":{"type":"string","format":"double","examples":["0.000001"]},"maxPrice":{"type":"string","format":"double","examples":["922327.0"]},"priceStep":{"type":"string","format":"double","examples":["0.000001"]},"minLotSize":{"type":"string","format":"double","examples":["0.0001"]},"lotStep":{"type":"string","format":"double","examples":["0.0001"]},"maxMarketBuyAmount":{"type":"string","format":"double","examples":["1527.51364395"]},"maxMarketSellAmount":{"type":"string","format":"double","examples":["1527.51364395"]},"priceMultiplierDown":{"type":"string","format":"double","examples":["0.2"]},"priceMultiplierUp":{"type":"string","format":"double","examples":["5.0"]},"minTotal":{"type":"string","format":"double","examples":["0.0001"]},"minMarketTotal":{"type":"string","format":"double","examples":["0.0001"]},"maxTotal":{"type":"string","format":"double","examples":["9000000.0"]},"maxLotSize":{"type":"string","format":"double","examples":["100000.0"]}}},"examples":[{"last":"0.066703","bid":"0.066703","ask":"0.066704","name":"Ethereum","orderbook_ask":"0.066704","orderbook_bid":"0.066703","orderbook_last":"0.066703","orderbook_price_currency":"BTC","strategy_name":"orderbook_price","contract_strategy_name":"orderbook_price","minPrice":"0.000001","maxPrice":"922327.0","priceStep":"0.000001","minLotSize":"0.0001","lotStep":"0.0001","maxMarketBuyAmount":"1527.51364395","maxMarketSellAmount":"1527.51364395","priceMultiplierDown":"0.2","priceMultiplierUp":"5.0","minTotal":"0.0001","minMarketTotal":"0.0001","maxTotal":"9000000.0","maxLotSize":"100000.0"}]}}}}}}}}}},"/ver1/bots/account_trade_info":{"get":{"description":"Account Trade Info (Permission: NONE, Security: SIGNED)\n","tags":["bots"],"operationId":"getVer1BotsAccountTradeInfo","parameters":[{"$ref":"#/components/parameters/accountIdQueryRequiredParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"},"400":{"$ref":"#/components/responses/ErrorResponse"},"401":{"$ref":"#/components/responses/ErrorResponse"},"404":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/bots/strategy_list":{"get":{"tags":["bots"],"description":"Available strategy list for bot (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsStrategyList","parameters":[{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/botQueryParam"},{"$ref":"#/components/parameters/strategyParam"}],"responses":{"200":{"$ref":"#/components/responses/BotsStrategyListResponse"}}}},"/ver1/bots/pairs_black_list":{"get":{"tags":["bots"],"description":"Black List for bot pairs (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsPairsBlackList","responses":{"200":{"$ref":"#/components/responses/BotsPairsBlackListResponse"}}}},"/ver1/bots/update_pairs_black_list":{"post":{"tags":["bots"],"description":"Create or Update pairs BlackList for bots (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsUpdatePairsBlackList","requestBody":{"$ref":"#/components/requestBodies/BotsUpdatePairsBlackListRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/create_bot":{"post":{"tags":["bots"],"description":"Create bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsCreateBot","requestBody":{"$ref":"#/components/requestBodies/BotCreateRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots":{"get":{"tags":["bots"],"description":"User bots (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1Bots","parameters":[{"$ref":"#/components/parameters/botShowLimitParam"},{"$ref":"#/components/parameters/offsetParam"},{"$ref":"#/components/parameters/dateFilterFromParam"},{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/activationParam"},{"$ref":"#/components/parameters/strategyParam"},{"$ref":"#/components/parameters/sortByParam"},{"$ref":"#/components/parameters/sortDirectionParam"},{"$ref":"#/components/parameters/quoteParam"},{"$ref":"#/components/parameters/botFormTypeParam"}],"responses":{"200":{"$ref":"#/components/schemas/MarketplaceBotEntities"}}}},"/ver1/bots/stats_by_date":{"get":{"tags":["bots"],"description":"Get bot stats by date (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsStatsByDate","parameters":[{"$ref":"#/components/parameters/dateRequiredParam"},{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/botIdQueryParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/stats":{"get":{"tags":["bots"],"description":"Get bot stats (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsStats","parameters":[{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/botIdQueryParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/profit_by_day":{"get":{"tags":["bots"],"description":"Get bot profits grouped by day (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsIdProfitByDay","parameters":[{"$ref":"#/components/parameters/botIdParam"},{"name":"days","in":"query","schema":{"$ref":"#/components/schemas/TimeUnitType"}}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/copy_and_create":{"post":{"tags":["bots"],"description":"POST /bots/:id/copy_and_create. Permission: BOTS_WRITE, Security: SIGNED\n","operationId":"postVer1BotsBotIdCopyAndCreate","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/BotCopyAndCreateRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/update":{"patch":{"tags":["bots"],"description":"Edit bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"patchVer1BotsBotIdUpdate","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/BotUpdateRequest"},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/disable":{"post":{"tags":["bots"],"description":"Disable bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdDisable","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"201":{"$ref":"#/components/responses/BotResponse"}}}},"/ver1/bots/{bot_id}/enable":{"post":{"tags":["bots"],"description":"Enable bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdEnable","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/start_new_deal":{"post":{"tags":["bots"],"description":"Start new deal asap (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdStartNewDeal","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/BotStartNewDealRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/delete":{"post":{"tags":["bots"],"description":"Delete bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdDelete","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"201":{"$ref":"#/components/responses/BooleanResponse"},"403":{"$ref":"#/components/responses/ErrorResponse"}}}},"/ver1/bots/{bot_id}/panic_sell_all_deals":{"post":{"tags":["bots"],"description":"Panic sell all bot deals (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdPanicSellAllDeals","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/cancel_all_deals":{"post":{"tags":["bots"],"description":"Cancel all bot deals (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1BotsBotIdCancelAllDeals","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/deals_stats":{"get":{"tags":["bots"],"description":"Bot deals stats (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsBotIdDealsStats","parameters":[{"$ref":"#/components/parameters/botIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/bots/{bot_id}/show":{"get":{"tags":["bots"],"description":"Bot info (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1BotsBotIdShow","parameters":[{"$ref":"#/components/parameters/botIdParam"},{"name":"include_events","in":"query","schema":{"type":"boolean","default":false}}],"responses":{"200":{"$ref":"#/components/schemas/MarketplaceBotEntity"}}}},"/ver1/deals":{"get":{"tags":["deals"],"description":"User deals (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1Deals","parameters":[{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"},{"$ref":"#/components/parameters/dateFilterFromParam"},{"$ref":"#/components/parameters/dateFilterToParam"},{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/botIdQueryParam"},{"name":"note","in":"query","description":"Note","schema":{"type":"string"}},{"name":"scope","in":"query","description":"active - active deals, finished - finished deals, completed - successfully completed, cancelled - cancelled deals, failed - failed deals, any other value or null (default) - all deals\n","schema":{"type":"string"}},{"name":"order","in":"query","schema":{"$ref":"#/components/schemas/SortByDealsEnum"}},{"$ref":"#/components/parameters/orderDirectionParam"},{"$ref":"#/components/parameters/baseParam"},{"$ref":"#/components/parameters/quoteParam"}],"responses":{"200":{"$ref":"#/components/responses/DealsResponse"}}}},"/ver1/deals/{deal_id}/convert_to_smart_trade":{"post":{"tags":["deals"],"description":"Convert to smart trade (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdConvertToSmartTrade","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/DealConvertToSmartTradeRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/update_max_safety_orders":{"post":{"tags":["deals"],"description":"Update max safety orders (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdUpdateMaxSafetyOrders","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/DealUpdateMaxSafetyOrdersRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/panic_sell":{"post":{"tags":["deals"],"description":"Panic sell deal (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdPanicSell","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/cancel":{"post":{"tags":["deals"],"description":"Cancel deal (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdCancel","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/update_deal":{"patch":{"tags":["deals"],"description":"Update deal (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"patchVer1DealsDealIdUpdateDeal","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/DealUpdateRequest"},"responses":{"200":{"$ref":"#/components/responses/DealResponse"}}}},"/ver1/deals/{deal_id}/show":{"get":{"tags":["deals"],"description":"Info about specific deal (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1DealsDealIdShow","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"responses":{"200":{"$ref":"#/components/responses/DealResponse"}}}},"/ver1/deals/{deal_id}/cancel_order":{"post":{"tags":["deals"],"description":"Cancel manual safety orders (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdCancelOrder","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/DealCancelOrderRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/market_orders":{"get":{"tags":["deals"],"description":"Deal safety orders (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1DealsDealIdMarketOrders","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/add_funds":{"post":{"tags":["deals"],"description":"Adding manual safety order (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1DealsDealIdAddFunds","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/DealAddFundsRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/deals/{deal_id}/data_for_adding_funds":{"get":{"tags":["deals"],"description":"Info required to add funds correctly: available amounts, exchange limitations etc  (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1DealsDealIdDataForAddingFunds","parameters":[{"$ref":"#/components/parameters/dealIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades":{"get":{"tags":["smart_trades_v2"],"description":"Get smart trade history (Permission: SMART_TRADE_READ, Security: SIGNED)\n","operationId":"getV2SmartTrades","parameters":[{"$ref":"#/components/parameters/accountIdQueryParam"},{"$ref":"#/components/parameters/pairParam"},{"$ref":"#/components/parameters/smartTradeTypeParam"},{"$ref":"#/components/parameters/pageParam"},{"$ref":"#/components/parameters/perPageParam"},{"$ref":"#/components/parameters/smartTradeStatusParam"},{"$ref":"#/components/parameters/smartTradeOrderByParam"},{"$ref":"#/components/parameters/orderDirectionParam"},{"$ref":"#/components/parameters/dateFilterFromParam"},{"$ref":"#/components/parameters/dateFilterToParam"},{"$ref":"#/components/parameters/baseParam"},{"$ref":"#/components/parameters/quoteParam"}],"responses":{"200":{"$ref":"#/components/responses/SmartTradesResponse"}}},"post":{"tags":["smart_trades_v2"],"description":"Create smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTrades","requestBody":{"$ref":"#/components/requestBodies/SmartTradeCreateRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/reduce_funds_info":{"get":{"tags":["smart_trades_v2"],"description":"Reduce funds for smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"getV2SmartTradesIdReduceFundsInfo","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}":{"get":{"tags":["smart_trades_v2"],"description":"Get smart trade v2 by id (Permission: SMART_TRADE_READ, Security: SIGNED)\n","operationId":"getV2SmartTradesId","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"200":{"$ref":"#/components/responses/SmartTradeResponse"}}},"delete":{"tags":["smart_trades_v2"],"description":"Cancel smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"deleteV2SmartTradesId","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"204":{"$ref":"#/components/responses/TodoResponse"}}},"patch":{"tags":["smart_trades_v2"],"description":"Update smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"patchV2SmartTradesId","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/SmartTradeUpdateRequest"},"responses":{"200":{"$ref":"#/components/responses/SmartTradeResponse"}}}},"/v2/smart_trades/{smart_trade_id}/reduce_funds":{"post":{"tags":["smart_trades_v2"],"description":"Reduce funds for smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdReduceFunds","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/SmartTradeReduceFundsRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/add_funds":{"post":{"tags":["smart_trades_v2"],"description":"Average for smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdAddFunds","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/SmartTradeAddFundsRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/close_by_market":{"post":{"tags":["smart_trades_v2"],"description":"Close by market smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdCloseByMarket","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/force_start":{"post":{"tags":["smart_trades_v2"],"description":"Force start smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdForceStart","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/force_process":{"post":{"tags":["smart_trades_v2"],"description":"Process smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdForceProcess","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/set_note":{"post":{"tags":["smart_trades_v2"],"description":"Set note to smart trade v2 (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesIdSetNote","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/SmartTradeSetNoteRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/trades":{"get":{"tags":["smart_trades_v2"],"description":"Get smart trade v2 trades (Permission: SMART_TRADE_READ, Security: SIGNED)\n","operationId":"getV2SmartTradesSmartTradeIdTrades","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/trades/{trade_id}/close_by_market":{"post":{"tags":["smart_trades_v2"],"description":"Panic close trade by market (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"postV2SmartTradesSmartTradeIdTradesIdCloseByMarket","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"},{"$ref":"#/components/parameters/tradeIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/v2/smart_trades/{smart_trade_id}/trades/{trade_id}":{"delete":{"tags":["smart_trades_v2"],"description":"Cancel trade (Permission: SMART_TRADE_WRITE, Security: SIGNED)\n","operationId":"deleteV2SmartTradesSmartTradeIdTradesId","parameters":[{"$ref":"#/components/parameters/smartTradeIdParam"},{"$ref":"#/components/parameters/tradeIdParam"}],"responses":{"204":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/ai":{"post":{"tags":["grid_bots"],"description":"Create AI Grid Bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1GridBotsAi","requestBody":{"$ref":"#/components/requestBodies/GridBotCreateAiRequest"},"responses":{"201":{"$ref":"#/components/responses/GridBotsResponse"}}}},"/ver1/grid_bots/manual":{"post":{"tags":["grid_bots"],"description":"Create Grid Bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1GridBotsManual","requestBody":{"$ref":"#/components/requestBodies/GridBotCreateManualRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/ai_settings":{"get":{"tags":["grid_bots"],"description":"Get AI settings (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsAiSettings","parameters":[{"$ref":"#/components/parameters/pairRequiredParam"},{"$ref":"#/components/parameters/marketCodeRequiredParam"},{"name":"total_quantity","in":"query","description":"Total amount for bot usage","schema":{"type":"number","format":"double"}}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots":{"get":{"tags":["grid_bots"],"description":"Grid bots list (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBots","parameters":[{"name":"account_ids","in":"query","description":"Filter by account id","schema":{"$ref":"#/components/schemas/AccountIdTypes"}},{"name":"account_types","in":"query","description":"Filter by account type","schema":{"type":"string"}},{"name":"state","in":"query","description":"Filter by bot state","schema":{"$ref":"#/components/schemas/EnabledEnum"}},{"$ref":"#/components/parameters/sortByGridBotParam"},{"$ref":"#/components/parameters/sortDirectionParam"},{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"},{"$ref":"#/components/parameters/dateFilterFromParam"},{"$ref":"#/components/parameters/baseParam"},{"$ref":"#/components/parameters/quoteParam"}],"responses":{"200":{"$ref":"#/components/responses/GridBotsResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/note":{"post":{"tags":["grid_bots"],"description":"Grid Bot Note (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1GridBotsIdNote","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/GridBotNoteRequest"},"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/events":{"get":{"tags":["grid_bots"],"description":"Grid Bot Events (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsIdEvents","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"},{"$ref":"#/components/parameters/pageParam"},{"$ref":"#/components/parameters/perPageParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/market_orders":{"get":{"tags":["grid_bots"],"description":"Grid Bot Market Orders (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsIdMarketOrders","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"},{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/profits":{"get":{"tags":["grid_bots"],"description":"Grid Bot Profits (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsIdProfits","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"},{"$ref":"#/components/parameters/dateFilterFromParam"},{"$ref":"#/components/parameters/dateFilterToParam"}],"responses":{"200":{"$ref":"#/components/responses/GridBotProfitsResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/ai":{"patch":{"tags":["grid_bots"],"description":"Edit Grid Bot (AI) (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"patchVer1GridBotsIdAi","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/GridBotEditAiRequest"},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/manual":{"patch":{"tags":["grid_bots"],"description":"Edit Grid Bot (Manual) (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"patchVer1GridBotsIdManual","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"requestBody":{"$ref":"#/components/requestBodies/GridBotEditManualRequest"},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}":{"get":{"tags":["grid_bots"],"description":"Show Grid Bot (Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsId","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}},"delete":{"tags":["grid_bots"],"description":"Delete Grid Bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"deleteVer1GridBotsId","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"responses":{"204":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/disable":{"post":{"tags":["grid_bots"],"description":"Disable Grid Bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1GridBotsIdDisable","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/enable":{"post":{"tags":["grid_bots"],"description":"Enable Grid Bot (Permission: BOTS_WRITE, Security: SIGNED)\n","operationId":"postVer1GridBotsIdEnable","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"responses":{"201":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/grid_bots/{grid_bot_id}/required_balances":{"get":{"tags":["grid_bots"],"description":"Get required balances to start bot(Permission: BOTS_READ, Security: SIGNED)\n","operationId":"getVer1GridBotsIdRequiredBalances","parameters":[{"$ref":"#/components/parameters/gridBotIdParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/marketplace/presets":{"get":{"tags":["marketplace"],"description":"Marketplace presets (Permission: NONE, Security: SIGNED)\n","operationId":"getVer1MarketplacePresets","parameters":[{"name":"profit_per_day_from","in":"query","schema":{"type":"number","format":"double"}},{"name":"profit_per_day_to","in":"query","schema":{"type":"number","format":"double"}},{"name":"profit_per_month_from","in":"query","schema":{"type":"number","format":"double"}},{"name":"profit_per_month_to","in":"query","schema":{"type":"number","format":"double"}},{"name":"with_all_market_pairs","in":"query","schema":{"type":"boolean"}},{"name":"days_running_from","in":"query","schema":{"$ref":"#/components/schemas/TimeUnitType"}},{"name":"days_running_to","in":"query","schema":{"$ref":"#/components/schemas/TimeUnitType"}},{"name":"bot_type","in":"query","schema":{"type":"string"}},{"name":"bot_strategy","in":"query","schema":{"type":"string"}},{"name":"cmc","in":"query","schema":{"type":"string"}},{"$ref":"#/components/parameters/sortByParam"},{"$ref":"#/components/parameters/sortDirectionParam"},{"name":"page","in":"query","schema":{"$ref":"#/components/schemas/PageType"}},{"name":"per_page","in":"query","schema":{"$ref":"#/components/schemas/PerPageType"}},{"name":"account_types","in":"query","schema":{"$ref":"#/components/schemas/MarketCodeTypes"}},{"name":"markets","in":"query","schema":{"$ref":"#/components/schemas/SymbolStringTypes"}},{"name":"pairs","in":"query","schema":{"$ref":"#/components/schemas/PairTypes"}},{"name":"deal_start_conditions","in":"query","schema":{"$ref":"#/components/schemas/MarketplacePresetsDealStartConditionEnums"}}],"responses":{"200":{"$ref":"#/components/responses/MarketplacePresetsResponse"}}}},"/ver1/marketplace/items":{"get":{"tags":["marketplace"],"description":"All marketplace items (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getVer1MarketplaceItems","parameters":[{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"},{"name":"scope","in":"query","description":"paid - show only paid signal providers. free - show only free signal providers\n","schema":{"$ref":"#/components/schemas/MarketPlaceScopeEnum"}},{"name":"order","in":"query","schema":{"$ref":"#/components/schemas/MarketPlaceOrderEnum"}},{"$ref":"#/components/parameters/localeParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/ver1/marketplaces/{marketplaceitem_id}/signals":{"get":{"tags":["marketplace"],"description":"Marketplace Item Signals (Permission: NONE, Security: NONE)\n","security":[],"operationId":"getVer1MarketplaceItemIdSignals","parameters":[{"$ref":"#/components/parameters/marketplaceitemIdParam"},{"$ref":"#/components/parameters/limitParam"},{"$ref":"#/components/parameters/offsetParam"},{"name":"order","in":"query","schema":{"$ref":"#/components/schemas/MarketPlaceSignalsOrderEnum"}},{"$ref":"#/components/parameters/orderDirectionParam"},{"$ref":"#/components/parameters/localeParam"}],"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/smart_trades/tv/webhooks":{"post":{"tags":["webhooks"],"security":[],"servers":[{"url":"https://app.3commas.io","description":"Webhooks server"}],"description":"Send webhooks to 3Commas SmartTrades\n","operationId":"tvsmarttrade","parameters":[{"description":"Insert your appropriate token from<br/> https://app.3commas.io/smart_trades/new > Presets\n","name":"tokens","in":"query","style":"form","explode":false,"required":true,"schema":{"type":"array","items":{"type":"string","pattern":"^[a-f0-9]{64}$"}}}],"responses":{"200":{"$ref":"#/components/responses/BooleanResponse"}}}},"/trade_signal/trading_view":{"post":{"tags":["webhooks"],"security":[],"servers":[{"url":"https://app.3commas.io","description":"Webhooks server"}],"description":"Send webhooks to 3Commas DCA bot.<p/> Make sure to <i>never publish</i> your <i>email_token</i>,<br/> since it is valid for your whole 3Commas account.<p/> <b><i>Please, else directly contact 3Commas' support<br/> to reset the</i> email_token.</b>\n        <p/>\n<a href=\"https://3commas.io/trading-view\">How do custom [DCA] TradingView signals work?</a> <p/> <a href=\"https://help.3commas.io/en/articles/3108938-how-to-use-tradingview-custom-signals\">How to use custom [DCA] signals?</a>\n","operationId":"tradingview_dca","requestBody":{"description":"Send trading view webhooks","content":{"application/json":{"schema":{"type":"array","items":{"oneOf":[{"required":["message_type","action","bot_id","email_token","pair"],"properties":{"message_type":{"type":"string","default":"bot","enum":["bot"]},"action":{"type":"string","enum":["close_at_market_price","close_at_market_price_all","close_at_market_price_all_and_stop_bot","add_funds_in_quote","add_funds_in_base","cancel","cancel_all_and_stop_bot","cancel_all","stop_bot","start_bot","start_bot_and_start_deal","start_trailing"]},"bot_id":{"type":"integer","format":"int32"},"email_token":{"type":"string","pattern":"^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$"},"delay_seconds":{"type":"integer","format":"int32"},"pair":{"$ref":"#/components/schemas/PairType"}}},{"required":["message_type","action","account_id","email_token"],"properties":{"message_type":{"type":"string","default":"account","enum":["account"]},"action":{"type":"string","enum":["start_all_long","stop_all_long","start_all_short","stop_all_short"]},"account_id":{"type":"integer","format":"int32"},"email_token":{"type":"string","pattern":"^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$"},"delay_seconds":{"type":"integer","format":"int32"}}}]}}}},"required":true},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/webhooks/trading_view":{"post":{"tags":["webhooks"],"security":[],"servers":[{"url":"https://app.3commas.io","description":"Webhooks server"}],"description":"Send webhooks to 3Commas signal bot.<p/> Make sure to <i>never publish</i> your <i>email_token</i>,<br/> since it is valid for your whole 3Commas account.<p/> <b><i>Please, else directly contact 3Commas' support<br/> to reset the</i> email_token.</b> <p/> <a href=\"https://help.3commas.io/en/collections/7070754-signal-bot\">How to configure a signal bot</a> </p> </p> <h3>TODO: Update requestBody and responseBody</h3>\n","operationId":"tradingview_signal","requestBody":{"required":true,"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/SignalBotIndicatorEntity"},{"$ref":"#/components/schemas/SignalBotStrategyEntity"}]}}}},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/smart_trades":{"post":{"tags":["streams"],"servers":[{"url":"wss://ws.3commas.io/websocket","description":"Websocket server"}],"security":[],"description":"Subscribe to Smart Trades Stream (Permission: SMART_TRADES_READ, Security: SIGNED)\n","operationId":"subscribeSmartTradesStream","requestBody":{"description":"Storage data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChannelMessageEntity"}}}},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}},"/deals":{"post":{"tags":["streams"],"servers":[{"url":"wss://ws.3commas.io/websocket","description":"Websocket server"}],"security":[],"description":"Subscribe to Deals Stream (Permission: NONE, Security: SIGNED)\n","operationId":"subscribeDealsStream","requestBody":{"description":"Storage data","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChannelMessageEntity"}}}},"responses":{"200":{"$ref":"#/components/responses/TodoResponse"}}}}},"components":{"schemas":{"PongEntity":{"description":"Pong - connectivity successfully tested\n","properties":{"pong":{"type":"string","enum":["pong"]}}},"TimeEntity":{"description":"3Commas server time as UNIX timestamp","properties":{"server_time":{"$ref":"#/components/schemas/TimeUnitType"}}},"DevApiValidEntity":{"properties":{"valid":{"type":"boolean"}}},"MiniAppsTokenType":{"type":"string"},"MiniAppsKeyType":{"type":"string"},"MiniAppsStorageEntity":{"required":["data","key"],"properties":{"key":{"$ref":"#/components/schemas/MiniAppsKeyType"},"data":{"type":"object"}}},"LocaleEnum":{"type":"string","description":"Available locales","default":"en","enum":["en","ru","zh","zh-CN","es","pt","ko","fr","cs","tr","de","it"]},"LocaleType":{"required":["locale"],"properties":{"locale":{"$ref":"#/components/schemas/LocaleEnum"}}},"UserPermissionEntity":{"properties":{"smart_trades_read":{"type":"boolean"},"smart_trades_write":{"type":"boolean"},"bots_read":{"type":"boolean"},"bots_write":{"type":"boolean"},"accounts_read":{"type":"boolean"},"accounts_write":{"type":"boolean"}},"examples":["{\n  \"smart_trades_read\": true,\n  \"smart_trades_write\": true,\n  \"bots_read\": true,\n  \"bots_write\": true,\n  \"accounts_read\": true,\n  \"accounts_write\": true\n}\n"]},"AccountModeEnum":{"type":"string","enum":["paper","real"]},"UserModeEntity":{"required":["mode"],"properties":{"mode":{"$ref":"#/components/schemas/AccountModeEnum"}}},"PortfolioEntity":{"properties":{"items":{"$ref":"#/components/schemas/PortfolioItemEntities"},"pagination":{"properties":{"page":{"$ref":"#/components/schemas/PageType"},"per_page":{"$ref":"#/components/schemas/PerPageType"},"has_more_items":{"type":"boolean"}}}}},"PortfolioItemEntities":{"type":"array","items":{"$ref":"#/components/schemas/PortfolioItemEntity"}},"PortfolioItemEntity":{"properties":{"name":{"$ref":"#/components/schemas/NameType"},"id":{"type":"string"},"created_at":{"$ref":"#/components/schemas/DateTimeType"},"portfolio_entries":{"$ref":"#/components/schemas/PortfolioEntryEntity"}}},"PortfolioEntryEntity":{"properties":{"target_percentage":{"type":"string"},"currency_code":{"type":"string"}}},"LooseAccountsCreateEntity":{"required":["name","tokens"],"properties":{"name":{"$ref":"#/components/schemas/NameType"},"tokens":{"$ref":"#/components/schemas/TokenEntities"},"include_in_summary":{"type":"boolean"}}},"LooseAccountsUpdateEntity":{"required":["tokens"],"properties":{"name":{"$ref":"#/components/schemas/NameType"},"tokens":{"$ref":"#/components/schemas/TokenEntities"},"include_in_summary":{"type":"boolean"}}},"LooseAccountsEntities":{"type":"array","items":{"$ref":"#/components/schemas/LooseAccountsEntity"}},"LooseAccountsEntity":{"properties":{"id":{"$ref":"#/components/schemas/AccountIdType"},"name":{"$ref":"#/components/schemas/NameType"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"type":{"type":"string","examples":["Accounts::LooseAccount"]},"is_deleted":{"type":"boolean","examples":[false]},"is_locked":{"type":"boolean","examples":[false]}}},"LooseAccountsCurrencyEntities":{"type":"array","items":{"$ref":"#/components/schemas/LooseAccountsCurrencyEntity"}},"LooseAccountsCurrencyEntity":{"properties":{"id":{"$ref":"#/components/schemas/LooseAccountCurrencyIdType"},"name_and_code":{"type":"string","examples":["Bitcoin (BTC)"]},"code":{"$ref":"#/components/schemas/SymbolStringType"},"name":{"$ref":"#/components/schemas/NameType"},"btc_price":{"$ref":"#/components/schemas/PriceType"},"usd_price":{"$ref":"#/components/schemas/PriceType"},"primary_display_currency_price":{"$ref":"#/components/schemas/DisplayValueEntity"}}},"NomicsIdType":{"description":"Market code from /accounts/market_list (market_code from account model)\n","type":"string","examples":["binance"]},"MarketCodeType":{"description":"Market code from /accounts/market_list (market_code from account model) As fast_connect_action_name only spot names are used.\n","type":"string","examples":["binance"]},"MarketCodeTypes":{"type":"array","items":{"$ref":"#/components/schemas/MarketCodeType"}},"FormFieldEntity":{"properties":{"field":{"type":"string"},"localized_name":{"$ref":"#/components/schemas/NameType"}},"required":["field","localized_name"],"examples":[{"field":"api_key","localized_name":"API Key:"}]},"FormFieldEntities":{"type":"array","items":{"$ref":"#/components/schemas/FormFieldEntity"}},"ConnectionTypeEnum":{"type":"string","enum":["fields"]},"ConnectionFlowEnums":{"type":"array","items":{"$ref":"#/components/schemas/ConnectionFlowEnum"}},"ConnectionFlowEnum":{"type":"string","enum":["form","fast_connect"]},"TrustedIpType":{"type":"string","pattern":"^(\\d{1,3}\\.){4}$"},"TrustedIps":{"type":"array","items":{"$ref":"#/components/schemas/TrustedIpType"}},"TrustedIpsInputTypeEnum":{"type":"string","enum":["inline","one_by_one"]},"MarketListItemEntity":{"properties":{"market_name":{"$ref":"#/components/schemas/NameType"},"market_url":{"type":"string","examples":["https://www.binance.com/en/futures/ref/108190303"]},"market_icon":{"type":"string","examples":["https://3commas.io/img/exchanges/binance.png"]},"market_trust_message":{"type":"string","enum":["3Commas will not have access to transfer or withdraw your assets. Each exchange connects with encrypted API keys","1. Log in to your exchange account and go to API Settings \\n2. Select third-party apps and choose 3Commas \\n3. Paste generated data in inputs below."]},"help_link":{"type":"string","examples":["https://help.3commas.io/en/articles/3109051"]},"nomics_id":{"$ref":"#/components/schemas/NomicsIdType"},"market_code":{"$ref":"#/components/schemas/MarketCodeType"},"form_fields":{"description":"List of required and optional form fields to create a new account\n","properties":{"required":{"$ref":"#/components/schemas/FormFieldEntities"},"optional":{"$ref":"#/components/schemas/FormFieldEntities"}}},"connection_type":{"$ref":"#/components/schemas/ConnectionTypeEnum"},"available_connection_flows":{"$ref":"#/components/schemas/ConnectionFlowEnums"},"trusted_ips":{"$ref":"#/components/schemas/TrustedIps"},"trusted_ips_input_type":{"$ref":"#/components/schemas/TrustedIpsInputTypeEnum"},"fast_connect_action_name":{"$ref":"#/components/schemas/MarketCodeType"}}},"MarketListItemEntities":{"type":"array","items":{"$ref":"#/components/schemas/MarketListItemEntity"}},"PairType":{"type":"string","pattern":"^[A-Z]{3,}(_[A-Z0-9]{3,}){1,}$","description":"Format: QUOTE_BASE\n","examples":["BUSD_FTT"]},"PairTypes":{"description":"POST:<br/> SingleBot: Pass single pair MultiBot:  Pass any other number of pairs\n","type":"array","items":{"$ref":"#/components/schemas/PairType"},"examples":[["BTC_ETH","BTC_LTC"]]},"CurrencyRateEntity":{"properties":{"last":{"$ref":"#/components/schemas/PriceType"},"bid":{"$ref":"#/components/schemas/PriceType"},"ask":{"$ref":"#/components/schemas/PriceType"},"orderbook_ask":{"$ref":"#/components/schemas/PriceType"},"orderbook_bid":{"$ref":"#/components/schemas/PriceType"},"orderbook_last":{"$ref":"#/components/schemas/PriceType"},"orderbook_price_currency":{"$ref":"#/components/schemas/SymbolStringType"},"strategy_name":{"examples":["orderbook_price"],"type":"string"},"contract_strategy_name":{"examples":["orderbook_price"],"type":"string"},"minPrice":{"$ref":"#/components/schemas/PriceType"},"maxPrice":{"$ref":"#/components/schemas/PriceType"},"priceStep":{"$ref":"#/components/schemas/PriceType"},"minLotSize":{"$ref":"#/components/schemas/PriceType"},"lotStep":{"$ref":"#/components/schemas/PriceType"},"minTotal":{"$ref":"#/components/schemas/OrderVolumeType"},"maxMarketBuyAmount":{"$ref":"#/components/schemas/OrderVolumeType"},"maxMarketSellAmount":{"$ref":"#/components/schemas/OrderVolumeType"},"priceMultiplierDown":{"$ref":"#/components/schemas/PriceType"},"priceMultiplierUp":{"$ref":"#/components/schemas/PriceType"},"maxLotSize":{"$ref":"#/components/schemas/OrderVolumeType"}}},"CurrencyRateWithLeverageEntity":{"properties":{"last":{"$ref":"#/components/schemas/PriceType"},"bid":{"$ref":"#/components/schemas/PriceType"},"ask":{"$ref":"#/components/schemas/PriceType"},"orderbook_ask":{"$ref":"#/components/schemas/PriceType"},"orderbook_bid":{"$ref":"#/components/schemas/PriceType"},"orderbook_last":{"$ref":"#/components/schemas/PriceType"},"orderbook_price_currency":{"$ref":"#/components/schemas/SymbolStringType"},"strategy_name":{"examples":["orderbook_price"],"type":"string"},"contract_strategy_name":{"examples":["orderbook_price"],"type":"string"},"leverage_data":{"type":"array","items":{"properties":{"TODO":{"type":"string"}}}},"minPrice":{"$ref":"#/components/schemas/PriceType"},"maxPrice":{"$ref":"#/components/schemas/PriceType"},"priceStep":{"$ref":"#/components/schemas/PriceType"},"minLotSize":{"$ref":"#/components/schemas/PriceType"},"lotStep":{"$ref":"#/components/schemas/PriceType"},"minTotal":{"$ref":"#/components/schemas/OrderVolumeType"},"maxMarketBuyAmount":{"$ref":"#/components/schemas/OrderVolumeType"},"maxMarketSellAmount":{"$ref":"#/components/schemas/OrderVolumeType"},"priceMultiplierDown":{"$ref":"#/components/schemas/PriceType"},"priceMultiplierUp":{"$ref":"#/components/schemas/PriceType"},"maxLotSize":{"$ref":"#/components/schemas/OrderVolumeType"}}},"AccountEntity":{"properties":{"id":{"oneOf":[{"$ref":"#/components/schemas/AccountIdType"},{"enum":["summary"]}]},"auto_balance_period":{"$ref":"#/components/schemas/IntegerPositiveType"},"auto_balance_portfolio_id":{"$ref":"#/components/schemas/PortfolioIdType"},"auto_balance_currency_change_limit":{"$ref":"#/components/schemas/IntegerPositiveType"},"autobalance_enabled":{"type":"boolean"},"hedge_mode_available":{"type":"boolean"},"hedge_mode_enabled":{"type":"boolean"},"is_locked":{"type":"boolean"},"smart_trading_supported":{"type":"boolean"},"smart_selling_supported":{"type":"boolean"},"available_for_trading":{"type":"array","items":{"type":"string"}},"stats_supported":{"type":"boolean"},"trading_supported":{"type":"boolean"},"market_buy_supported":{"type":"boolean"},"market_sell_supported":{"type":"boolean"},"conditional_buy_supported":{"type":"boolean"},"bots_allowed":{"type":"boolean"},"bots_ttp_allowed":{"type":"boolean"},"bots_tsl_allowed":{"type":"boolean"},"gordon_bots_available":{"type":"boolean"},"multi_bots_allowed":{"type":"boolean"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"last_auto_balance":{"type":"string","format":"date-time"},"fast_convert_available":{"description":"Sell all to USD/BTC possibility","type":"boolean"},"grid_bots_allowed":{"type":"boolean"},"api_key_invalid":{"type":"boolean","examples":[true]},"nomics_id":{"$ref":"#/components/schemas/NomicsIdType"},"market_icon":{"type":"string","format":"url"},"deposit_enabled":{"type":"boolean"},"include_in_summary":{"type":"boolean"},"supported_market_types":{"type":"array","items":{"type":"string","enum":["spot","futures","options"]}},"primary_display_currency_profit_percentage":{"$ref":"#/components/schemas/DisplayValueEntity"},"primary_display_currency_profit":{"$ref":"#/components/schemas/DisplayValueEntity"},"day_profit_primary_display_currency_percentage":{"$ref":"#/components/schemas/DisplayValueEntity"},"day_profit_primary_display_currency":{"$ref":"#/components/schemas/DisplayValueEntity"},"primary_display_currency_amount":{"$ref":"#/components/schemas/DisplayValueEntity"},"total_primary_display_currency_profit":{"$ref":"#/components/schemas/DisplayValueEntity"},"available_include_in_summary":{"type":"boolean"},"api_key":{"$ref":"#/components/schemas/AccountApiKeyType"},"name":{"$ref":"#/components/schemas/NameType"},"auto_balance_method":{"$ref":"#/components/schemas/AccountAutoBalanceMethodEnum"},"auto_balance_error":{"type":["string","null"],"examples":["Failed to autobalance"]},"customer_id":{"type":["string","null"]},"subaccount_name":{"$ref":"#/components/schemas/NameType"},"lock_reason":{"type":["string","null"],"examples":["API key is invalid"]},"btc_amount":{"$ref":"#/components/schemas/StringFloatType"},"usd_amount":{"$ref":"#/components/schemas/StringFloatType"},"day_profit_btc":{"$ref":"#/components/schemas/StringFloatType"},"day_profit_usd":{"$ref":"#/components/schemas/StringFloatType"},"day_profit_btc_percentage":{"$ref":"#/components/schemas/PercentageType"},"day_profit_usd_percentage":{"$ref":"#/components/schemas/PercentageType"},"btc_profit":{"$ref":"#/components/schemas/StringFloatType"},"usd_profit":{"$ref":"#/components/schemas/StringFloatType"},"usd_profit_percentage":{"$ref":"#/components/schemas/PercentageType"},"btc_profit_percentage":{"$ref":"#/components/schemas/PercentageType"},"total_btc_profit":{"$ref":"#/components/schemas/StringFloatNegativeType"},"total_usd_profit":{"$ref":"#/components/schemas/StringFloatNegativeType"},"pretty_display_type":{"type":"string"},"exchange_name":{"$ref":"#/components/schemas/NameType"},"market_code":{"$ref":"#/components/schemas/MarketCodeType"},"address":{"type":"string"},"api_keys_state":{"type":"string","enum":["ok","expired","expire_soon"]}}},"AccountEntities":{"type":"array","items":{"$ref":"#/components/schemas/AccountEntity"}},"ActiveBotsCountType":{"$ref":"#/components/schemas/CountType"},"ActiveDealsCountType":{"$ref":"#/components/schemas/CountType"},"ActiveSmartTradesCountType":{"$ref":"#/components/schemas/CountType"},"ActiveOrderCountType":{"$ref":"#/components/schemas/CountType"},"ActiveGridBotsCountType":{"$ref":"#/components/schemas/CountType"},"MaxActiveDealsType":{"$ref":"#/components/schemas/CountType"},"ActiveTradingEntity":{"properties":{"data":{"properties":{"active_bots_count":{"$ref":"#/components/schemas/ActiveBotsCountType"},"active_deals_count":{"$ref":"#/components/schemas/ActiveDealsCountType"},"active_smart_trades_count":{"$ref":"#/components/schemas/ActiveSmartTradesCountType"},"active_orders_count":{"$ref":"#/components/schemas/ActiveOrderCountType"},"active_grid_bots_count":{"$ref":"#/components/schemas/ActiveGridBotsCountType"}}}}},"NetworkInfoEntity":{"type":"array","items":{"$ref":"#/components/schemas/CurrencyNetworkList"}},"CurrencyNetworkList":{"properties":{"currency":{"$ref":"#/components/schemas/SymbolStringType"},"name":{"type":"string"},"deposit_enable":{"type":"boolean"},"withdraw_enable":{"type":"boolean"},"network_list":{"type":"array","items":{"$ref":"#/components/schemas/NetworkList"}}}},"NetworkList":{"properties":{"network":{"type":"string"},"default":{"type":"boolean"},"deposit_enable":{"type":"boolean"},"withdraw_enable":{"type":"boolean"},"deposit_tip":{"type":"string"},"withdraw_tip":{"type":"string"},"special_tip":{"type":"string"},"network_name":{"type":"string"},"network_url":{"type":"string","format":"url"},"address_regexp":{"type":"string"},"withdraw_fee":{"type":"string"},"withdraw_min":{"type":"string"},"withdrawMax":{"type":"string"},"withdrawMultiple":{"type":"string"},"memo_regexp":{"$ref":"#/components/schemas/NetworkListMemoRegexp"},"label":{"$ref":"#/components/schemas/NetworkListLabel"},"require_address_tag":{"type":"boolean"}}},"NetworkListLabel":{"type":"string","enum":["","MEMO/Tag"]},"NetworkListMemoRegexp":{"type":"string","enum":["","^[0-9A-Za-z\\-_]{1,120}$","\\w{0,120}","^((?!0)[0-9]{1,10})$","^[0-9A-Za-z\\-_,]{1,120}$","^[0-9a-zA-Z]{0,20}$","^[0-9A-Za-z\\-_]{1,32}$","^[0-9A-Za-z\\-_,.]{1,120}$","^[0-9A-Za-z-]{1,28}$"]},"TypesToConnectEntities":{"type":"array","items":{"$ref":"#/components/schemas/TypesToConnectEntity"}},"TypesToConnectEntity":{"properties":{"type":{"$ref":"#/components/schemas/MarketCodeType"},"connected":{"type":"boolean"},"available":{"type":"boolean"}}},"AccountNameType":{"properties":{"name":{"$ref":"#/components/schemas/NameType"}}},"AccountTypeType":{"properties":{"type":{"$ref":"#/components/schemas/MarketCodeType"}}},"AccountTypesToCreateType":{"properties":{"types_to_create":{"$ref":"#/components/schemas/MarketCodeTypes"}}},"AccountNameTypeEntity":{"allOf":[{"$ref":"#/components/schemas/AccountNameType"},{"$ref":"#/components/schemas/AccountTypeType"}]},"AccountNewBaseEntity":{"allOf":[{"$ref":"#/components/schemas/AccountNameTypeEntity"},{"$ref":"#/components/schemas/AccountTypesToCreateType"}]},"AccountApiKeyEntity":{"properties":{"api_key":{"$ref":"#/components/schemas/AccountApiKeyType"},"secret":{"$ref":"#/components/schemas/AccountApiKeySecretType"}}},"AccountPassphraseType":{"properties":{"passphrase":{"type":"string","description":"For Kucoin, OKX, Coinbase Pro"}}},"AccountCustomerIdType":{"properties":{"customer_id":{"type":"string","description":"For Bitstamp"}}},"AccountAddressType":{"properties":{"address":{"type":"string"}}},"AccountKeystoreEntity":{"properties":{"how_connect":{"type":"string","enum":["keystore"],"default":"keystore"},"keystore":{"description":"keystore file content. Requires if type = binance_dex and how_connect = keystore\n","type":"string","format":"binary"},"wallet_password":{"type":"string","format":"password","description":"Requires if type = binance_dex and how_connect = keystore"}}},"AccountMnenomicEntity":{"properties":{"how_connect":{"type":"string","enum":["mnemonic_phrase"],"default":"mnemonic_phrase"},"mnemonic_phrase":{"type":"string","description":"Requires if type = binance_dex and how_connect = mnemonic_phrase\n"}}},"AccountNew_ApiKeyEntity":{"required":["name","type","api_key","secret"],"allOf":[{"$ref":"#/components/schemas/AccountNewBaseEntity"},{"$ref":"#/components/schemas/AccountApiKeyEntity"}]},"AccountNew_PassphraseEntity":{"required":["passphrase"],"allOf":[{"$ref":"#/components/schemas/AccountNew_ApiKeyEntity"},{"$ref":"#/components/schemas/AccountPassphraseType"}]},"AccountNew_CustomerIdEntity":{"required":["customer_id"],"allOf":[{"$ref":"#/components/schemas/AccountNew_ApiKeyEntity"},{"$ref":"#/components/schemas/AccountCustomerIdType"}]},"AccountNew_WalletEntity":{"required":["name","type","address"],"allOf":[{"$ref":"#/components/schemas/AccountNameTypeEntity"},{"$ref":"#/components/schemas/AccountAddressType"}]},"AccountNew_BinanceDexKeystoreEntity":{"deprecated":true,"required":["name","type","how_connect","keystore","wallet_password"],"allOf":[{"$ref":"#/components/schemas/AccountNameTypeEntity"},{"$ref":"#/components/schemas/AccountKeystoreEntity"}]},"AccountNew_BinanceDexMnenomicEntity":{"deprecated":true,"required":["name","type","how_connect","mnemonic_phrase"],"allOf":[{"$ref":"#/components/schemas/AccountNameTypeEntity"},{"$ref":"#/components/schemas/AccountMnenomicEntity"}]},"AccountUpdateBaseEntity":{"properties":{"account_id":{"$ref":"#/components/schemas/AccountIdType"},"include_in_summary":{"type":"boolean"}}},"AccountUpdate_ApiKeyEntity":{"required":["account_id","api_key","secret"],"allOf":[{"$ref":"#/components/schemas/AccountUpdateBaseEntity"},{"$ref":"#/components/schemas/AccountNameType"},{"$ref":"#/components/schemas/AccountApiKeyEntity"}]},"AccountUpdate_PassphraseEntity":{"required":["passphrase"],"allOf":[{"$ref":"#/components/schemas/AccountUpdate_ApiKeyEntity"},{"$ref":"#/components/schemas/AccountPassphraseType"}]},"AccountUpdate_CustomerIdEntity":{"required":["customer_id"],"allOf":[{"$ref":"#/components/schemas/AccountUpdate_ApiKeyEntity"},{"$ref":"#/components/schemas/AccountCustomerIdType"}]},"AccountUpdate_WalletEntity":{"required":["account_id","address"],"allOf":[{"$ref":"#/components/schemas/AccountUpdateBaseEntity"},{"$ref":"#/components/schemas/AccountAddressType"}]},"AccountUpdate_BinanceDexKeystoreEntity":{"deprecated":true,"required":["account_id","how_connect","keystore","wallet_password"],"allOf":[{"$ref":"#/components/schemas/AccountUpdateBaseEntity"},{"$ref":"#/components/schemas/AccountKeystoreEntity"}]},"AccountUpdate_BinanceDexMnenomicEntity":{"deprecated":true,"required":["account_id","how_connect","mnemonic_phrase"],"allOf":[{"$ref":"#/components/schemas/AccountUpdateBaseEntity"},{"$ref":"#/components/schemas/AccountMnenomicEntity"}]},"SignalBotIndicatorEntity":{"properties":{"secret":{"type":"string","examples":["token"]},"max_lag":{"type":"string","examples":["300"]},"timestamp":{"type":"string","examples":["{{timenow}}"]},"trigger_price":{"type":"string","examples":["{{close}}"]},"tv_exchange":{"type":"string","examples":["{{exchange}}"]},"tv_instrument":{"type":"string","examples":["{{ticker}}"]},"action":{"type":"string","examples":["exit_long"]},"bot_uuid":{"type":"string","examples":["signal-bot-uuid"]},"order":{"type":"object","properties":{"amount":{"type":"string","examples":["{amount}"]},"currency_type":{"type":"string","enum":["margin_percent","quote","base"]}}}}},"SignalBotStrategyEntity":{"properties":{"secret":{"type":"string","examples":["token"]},"max_lag":{"type":"string","examples":["300"]},"timestamp":{"type":"string","examples":["{{timenow}}"]},"trigger_price":{"type":"string","examples":["{{close}}"]},"tv_exchange":{"type":"string","examples":["{{exchange}}"]},"tv_instrument":{"type":"string","examples":["{{ticker}}"]},"action":{"type":"string","examples":["{{strategy.order.action}}"]},"bot_uuid":{"type":"string","examples":["86a9ac05-8d79-44a9-bd34-a8dd2884db41"]},"strategy_info":{"type":"object","properties":{"market_position":{"type":"string","examples":["{{strategy.market_position}}"]},"market_position_size":{"type":"string","examples":["{{strategy.market_position_size}}"]},"prev_market_position":{"type":"string","examples":["{{strategy.prev_market_position}}"]},"prev_market_position_size":{"type":"string","examples":["{{strategy.prev_market_position_size}}"]}}},"order":{"type":"object","properties":{"amount":{"type":"string","examples":["{{strategy.order.contracts}}"]},"currency_type":{"type":"string","examples":["base"]}}}}},"IdType":{"description":"General ID type. Never use directly","type":"integer","format":"int32"},"PortfolioIdType":{"description":"Portfolio ID","$ref":"#/components/schemas/IdType"},"AccountIdType":{"description":"Account ID","$ref":"#/components/schemas/IdType"},"AccountIdTypes":{"type":"array","items":{"$ref":"#/components/schemas/AccountIdType"}},"LooseAccountCurrencyIdType":{"description":"Loose account currency ID","$ref":"#/components/schemas/IdType"},"BotIdType":{"description":"Bot ID","$ref":"#/components/schemas/IdType"},"DealIdType":{"description":"Deal ID","$ref":"#/components/schemas/IdType"},"SmartTradeIdType":{"description":"SmartTrade ID","$ref":"#/components/schemas/IdType"},"TradeIdType":{"description":"Trade ID","$ref":"#/components/schemas/IdType"},"GridBotIdType":{"description":"Grid bot ID","$ref":"#/components/schemas/IdType"},"GridLineIdType":{"description":"Grid line ID","$ref":"#/components/schemas/IdType"},"MarketplaceItemIdType":{"description":"Marketplace item ID","$ref":"#/components/schemas/IdType"},"MarketplaceBotIdType":{"description":"Marketplace bot ID","$ref":"#/components/schemas/IdType"},"AccountAutoBalanceMethodEnum":{"description":"Values: time, currency_change\n","type":"string","enum":["time","currency_change"]},"EnabledEnum":{"type":"string","enum":["enabled","disabled"]},"MarketPlaceScopeEnum":{"type":"string","default":"all","enum":["all","paid","free"]},"SmartTradeStatusEnum":{"type":"string","enum":["all","active","finished","successfully_finished","cancelled","failed"]},"SmartTradeEnum":{"type":"string","enum":["simple_buy","simple_sell","smart_sell","smart_trade","smart_cover","smart_buy"]},"MarketPlaceOrderEnum":{"type":"string","default":"newest","enum":["subscribers","name","newest"]},"MarketPlaceSignalsOrderEnum":{"type":"string","default":"date","enum":["pair","exchange","signal_type","date"]},"DepositWithdrawEnum":{"type":"string","enum":["deposit","withdraw"]},"DealsResponseEnum":{"description":"TODO: Check for nullable!\n","type":["string","null"],"default":"empty","enum":["empty","deal","market_order"]},"SmartBotSourceEnum":{"type":"string","enum":["mlqfl","qfl","ml","algo"]},"SmartBotStrategyEnum":{"type":"string","enum":["conservative","moderate","aggressive"]},"MarketplacePresetsDealStartConditionEnums":{"type":"array","items":{"$ref":"#/components/schemas/MarketplacePresetsDealStartConditionEnum"}},"MarketplacePresetsDealStartConditionEnum":{"type":"string","enum":["QFL","Trading View","New trade ASAP","CQS Scalping","RSI","ULT"]},"StrategyListEnum":{"description":"For manual signals: [{\"strategy\":\"manual\"}] or []<br> For non-stop(1 pair only): [{\"strategy\":\"nonstop\"}]<br> QFL: {\"options\": {\"type\": \"original\"}, {\"percent\": 3}, \"strategy\": \"qfl\"}] <br> TradingView: [{\"options\": {\"time\": \"5m\", \"type\": \"buy_or_strong_buy\", \"strategy\": \"trading_view\"}\n{\n  \"qfl\": {\n    \"strategy_type\": \"indicator\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"QFL (only long signals)\",\n    \"options\": {\n      \"type\": {\n        \"original\": \"Original\",\n        \"day_trade\": \"Day trading\",\n        \"conservative\": \"Conservative trader\",\n        \"position\": \"Position trader\"\n      },\n      \"percent\": null\n    },\n    \"accounts_whitelist\": [\n      \"Account::BinanceAccount\",\n      \"Account::BinanceFuturesAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::BinanceBrokerAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::HuobiAccount\",\n      \"Account::BittrexAccount\",\n      \"Account::OkexAccount\",\n      \"Account::BybitAccount\",\n      \"Account::GdaxAccount\",\n      \"Account::BitmexAccount\",\n      \"Accounts::BinanceBrokerFutures\",\n      \"Accounts::ThreecommasExchangeAccount\",\n      \"Accounts::ThreecommasFutures\",\n      \"Account::KucoinAccount\",\n      \"Account::KrakenAccount\",\n      \"Accounts::Ftx\"\n    ]\n  },\n  \"cqs_telegram\": {\n    \"strategy_type\": \"signal\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"CQS Scalping\",\n    \"accounts_whitelist\": [\n      \"Account::BinanceAccount\",\n      \"Account::BittrexAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::BinanceBrokerAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::BinanceFuturesAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::HuobiAccount\",\n      \"Accounts::ThreecommasExchangeAccount\",\n      \"Account::OkexAccount\",\n      \"Accounts::Ftx\"\n    ]\n  },\n  \"cqs_bitmex\": {\n    \"strategy_type\": \"signal\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"CQS BITMEX Scalping\",\n    \"accounts_whitelist\": [\n      \"Account::BitmexAccount\"\n    ]\n  },\n  \"manual\": {\n    \"strategy_type\": \"signal\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"Manually/API (Bot won't open new trades automatically)\"\n  },\n  \"tv_custom_signal\": {\n    \"strategy_type\": \"signal\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"Trading View custom signal\"\n  },\n  \"rsi\": {\n    \"name\": \"RSI\",\n    \"payed\": false,\n    \"beta\": false,\n    \"strategy_type\": \"indicator\",\n    \"options\": {\n      \"time\": {\n        \"3m\": \"3 minutes\",\n        \"5m\": \"5 minutes\",\n        \"15m\": \"15 minutes\",\n        \"30m\": \"30 minutes\",\n        \"1h\": \"1 hour\",\n        \"2h\": \"2 hours\",\n        \"4h\": \"4 hours\",\n        \"8h\": \"8 hours\",\n        \"1d\": \"1 day\",\n        \"3d\": \"3 days\",\n        \"1w\": \"1 week\"\n      },\n      \"points\": null,\n      \"trigger_condition\": {\n        \"less\": \"less\",\n        \"greater\": \"greater\",\n        \"crossing_above\": \"crossing_down\",\n        \"crossing_below\": \"crossing_up\"\n      },\n      \"time_period\": null\n    },\n    \"accounts_whitelist\": [\n      \"Account::BinanceFuturesAccount\",\n      \"Accounts::BinanceFuturesCoin\",\n      \"Accounts::Ftx\",\n      \"Accounts::FtxFutures\",\n      \"Account::BybitAccount\",\n      \"Accounts::BybitUsdtPerpetualAccount\",\n      \"Account::GdaxAccount\",\n      \"Account::KrakenAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::GateIoAccount\",\n      \"Accounts::BybitSpotAccount\",\n      \"Accounts::GateIoBtcPerpetualAccount\",\n      \"Accounts::GateIoUsdtPerpetualAccount\",\n      \"Account::BinanceAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::OkexAccount\",\n      \"Accounts::OkexFuturesAccount\"\n    ]\n  },\n  \"ult\": {\n    \"name\": \"ULT-7-14-28\",\n    \"payed\": false,\n    \"beta\": false,\n    \"strategy_type\": \"indicator\",\n    \"options\": {\n      \"time\": {\n        \"3m\": \"3 minutes\",\n        \"5m\": \"5 minutes\",\n        \"15m\": \"15 minutes\",\n        \"30m\": \"30 minutes\",\n        \"1h\": \"1 hour\",\n        \"2h\": \"2 hours\",\n        \"4h\": \"4 hours\",\n        \"8h\": \"8 hours\",\n        \"1d\": \"1 day\",\n        \"3d\": \"3 days\",\n        \"1w\": \"1 week\"\n      },\n      \"points\": null\n    },\n    \"accounts_whitelist\": [\n      \"Account::BinanceFuturesAccount\",\n      \"Accounts::BinanceFuturesCoin\",\n      \"Accounts::Ftx\",\n      \"Accounts::FtxFutures\",\n      \"Account::BybitAccount\",\n      \"Accounts::BybitUsdtPerpetualAccount\",\n      \"Account::GdaxAccount\",\n      \"Account::KrakenAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::GateIoAccount\",\n      \"Accounts::BybitSpotAccount\",\n      \"Accounts::GateIoBtcPerpetualAccount\",\n      \"Accounts::GateIoUsdtPerpetualAccount\",\n      \"Account::BinanceAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::OkexAccount\",\n      \"Accounts::OkexFuturesAccount\"\n    ]\n  },\n  \"b_bands_percent\": {\n    \"name\": \"Bollinger Bands %B\",\n    \"payed\": false,\n    \"beta\": false,\n    \"strategy_type\": \"indicator\",\n    \"options\": {\n      \"time\": {\n        \"3m\": \"3 minutes\",\n        \"5m\": \"5 minutes\",\n        \"15m\": \"15 minutes\",\n        \"30m\": \"30 minutes\",\n        \"1h\": \"1 hour\",\n        \"2h\": \"2 hours\",\n        \"4h\": \"4 hours\",\n        \"8h\": \"8 hours\",\n        \"1d\": \"1 day\",\n        \"3d\": \"3 days\",\n        \"1w\": \"1 week\"\n      },\n      \"points\": null,\n      \"trigger_condition\": {\n        \"less\": \"less\",\n        \"greater\": \"greater\",\n        \"crossing_above\": \"crossing_down\",\n        \"crossing_below\": \"crossing_up\"\n      },\n      \"time_period\": {\n        \"10\": \"10\",\n        \"20\": \"20\",\n        \"30\": \"30\",\n        \"40\": \"40\",\n        \"50\": \"50\"\n      },\n      \"deviation\": {\n        \"1\": \"1\",\n        \"2\": \"2\"\n      }\n    },\n    \"accounts_whitelist\": [\n      \"Account::BinanceFuturesAccount\",\n      \"Accounts::BinanceFuturesCoin\",\n      \"Accounts::Ftx\",\n      \"Accounts::FtxFutures\",\n      \"Account::BybitAccount\",\n      \"Accounts::BybitUsdtPerpetualAccount\",\n      \"Account::GdaxAccount\",\n      \"Account::KrakenAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::GateIoAccount\",\n      \"Accounts::BybitSpotAccount\",\n      \"Accounts::GateIoBtcPerpetualAccount\",\n      \"Accounts::GateIoUsdtPerpetualAccount\",\n      \"Account::BinanceAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::OkexAccount\",\n      \"Accounts::OkexFuturesAccount\"\n    ]\n  },\n  \"ta_preset\": {\n    \"name\": \"TA Presets\",\n    \"strategy_type\": \"indicator\",\n    \"beta\": false,\n    \"options\": {\n      \"time\": {\n        \"3m\": \"3 minutes\",\n        \"5m\": \"5 minutes\",\n        \"15m\": \"15 minutes\",\n        \"30m\": \"30 minutes\",\n        \"1h\": \"1 hour\",\n        \"2h\": \"2 hours\",\n        \"4h\": \"4 hours\",\n        \"8h\": \"8 hours\",\n        \"1d\": \"1 day\",\n        \"3d\": \"3 days\",\n        \"1w\": \"1 week\"\n      },\n      \"type\": {\n        \"BB-20-1-LB\": \"BB-20-1-LB\",\n        \"BB-20-2-LB\": \"BB-20-2-LB\",\n        \"MFI-14<40\": \"MFI-14 crosses 40\",\n        \"MFI-14<20\": \"MFI-14 crosses 20\",\n        \"CCI-40<-200\": \"CCI-40 crosses -200\",\n        \"BB-20-1-UB\": \"BB-20-1-UB\",\n        \"BB-20-2-UB\": \"BB-20-2-UB\",\n        \"MFI-14>65\": \"MFI-14 crosses 65\",\n        \"CCI-40>0\": \"CCI-40 crosses 0\",\n        \"CCI-40>100\": \"CCI-40 crosses 100\",\n        \"MACD-12-26-9\": \"MACD cross 12-26-9\",\n        \"Parabolic-SAR\": \"Parabolic SAR 0.02-0.02-0.2\",\n        \"SMA-20-50\": \"SMA 20 crosses 50\",\n        \"SMA-50-100\": \"SMA 50 crosses 100\",\n        \"SMA-50-200\": \"SMA 50 crosses 200\",\n        \"SMA-100-200\": \"SMA 100 crosses 200\",\n        \"Heikin-Ashi-1\": \"Heikin Ashi 1 candle\",\n        \"Heikin-Ashi-3\": \"Heikin Ashi 3 candles\",\n        \"Heikin-Ashi-5\": \"Heikin Ashi 5 candles\"\n      }\n    },\n    \"accounts_whitelist\": [\n      \"Account::BinanceFuturesAccount\",\n      \"Accounts::BinanceFuturesCoin\",\n      \"Accounts::Ftx\",\n      \"Accounts::FtxFutures\",\n      \"Account::BybitAccount\",\n      \"Accounts::BybitUsdtPerpetualAccount\",\n      \"Account::GdaxAccount\",\n      \"Account::KrakenAccount\",\n      \"Account::BinanceUsAccount\",\n      \"Account::GateIoAccount\",\n      \"Accounts::BybitSpotAccount\",\n      \"Accounts::GateIoBtcPerpetualAccount\",\n      \"Accounts::GateIoUsdtPerpetualAccount\",\n      \"Account::BinanceAccount\",\n      \"Account::BinanceJerseyAccount\",\n      \"Account::BinanceMarginAccount\",\n      \"Account::PaperTradingAccount\",\n      \"Account::OkexAccount\",\n      \"Accounts::OkexFuturesAccount\"\n    ]\n  },\n  \"trading_view\": {\n    \"strategy_type\": \"indicator\",\n    \"payed\": false,\n    \"beta\": false,\n    \"name\": \"Trading View\",\n    \"options\": {\n      \"time\": {\n        \"1m\": \"1 minute\",\n        \"5m\": \"5 minutes\",\n        \"15m\": \"15 minutes\",\n        \"1h\": \"1 hour\",\n        \"4h\": \"4 hours\",\n        \"1d\": \"1 day\",\n        \"1w\": \"1 week\",\n        \"1M\": \"1 month\",\n        \"cumulative\": \"Cumulative\"\n      },\n      \"type\": {\n        \"buy_or_strong_buy\": \"Buy\",\n        \"strong_buy\": \"Strong Buy\",\n        \"sell_or_strong_sell\": \"Sell\",\n        \"strong_sell\": \"Strong Sell\"\n      }\n    }\n  }\n} #TODO: To be continued\n"},"StrategyListTypes":{"examples":["[{'options'=>{'time'=>'5m', 'type'=>'buy_or_strong_buy'}, 'strategy'=>'trading_view'}, ...]\n"],"description":"For manual signals: [{\"strategy\":\"manual\"}] or []<br> For non-stop(1 pair only): [{\"strategy\":\"nonstop\"}]<br> QFL: {\"options\": {\"type\": \"original\"}, {\"percent\": 3}, \"strategy\": \"qfl\"}] <br> TradingView: [{\"options\": {\"time\": \"5m\", \"type\": \"buy_or_strong_buy\", \"strategy\": \"trading_view\"}\n","type":"array","items":{"$ref":"#/components/schemas/StrategyListEnum"}},"NameType":{"type":"string"},"BlackListType":{"required":["pairs"],"properties":{"pairs":{"$ref":"#/components/schemas/PairTypes"}}},"SymbolStringType":{"description":"Currency code(examples:\nCurrency code( - USDT)\n","type":"string","pattern":"^[A-Z]{3,}$","examples":["USDT"]},"SymbolStringTypes":{"description":"Array of currency codes","type":"array","items":{"$ref":"#/components/schemas/SymbolStringType"}},"TokenEntity":{"required":["code","amount"],"properties":{"code":{"$ref":"#/components/schemas/SymbolStringType"},"amount":{"type":"number","format":"double"}}},"TokenEntities":{"type":"array","items":{"$ref":"#/components/schemas/TokenEntity"}},"IntegerZeroPositiveType":{"format":"int32","minimum":0,"default":0},"IntegerPositiveType":{"description":"Description A","type":"integer","format":"int32","minimum":1,"default":1},"DoubleNegativeZeroType":{"type":"number","format":"double","maximum":0,"examples":[-0.002]},"DoublePositiveZeroType":{"type":"number","format":"double","minimum":0,"examples":[0.002]},"StringFloatNegativeType":{"type":"string","pattern":"^(\\-\\d+|\\d+)(.\\d+|)$","examples":["-0.002"]},"StringFloatPositiveType":{"type":"string","pattern":"^\\d+(.\\d+|)$","examples":["0.05"]},"StringFloatType":{"type":"string","pattern":"^(\\-?\\d+|\\d+)(.\\d+|)$","examples":["-0.002"]},"TimeUnitType":{"description":"Time Unit","$ref":"#/components/schemas/IntegerPositiveType"},"CountType":{"$ref":"#/components/schemas/IntegerZeroPositiveType"},"DateType":{"type":"string","format":"date"},"DateTimeType":{"type":"string","format":"date-time"},"PercentageNegativeType":{"$ref":"#/components/schemas/StringFloatNegativeType"},"PercentagePositiveType":{"$ref":"#/components/schemas/StringFloatPositiveType"},"PercentageType":{"$ref":"#/components/schemas/StringFloatType"},"DisplayValueEntity":{"properties":{"currency":{"$ref":"#/components/schemas/SymbolStringType"},"amount":{"$ref":"#/components/schemas/StringFloatType"}}},"TakeProfitType":{"description":"Target profit(percentage)","type":"number","format":"double","examples":["1.23"]},"CoefficientType":{"type":"number","format":"double","default":1},"MartingaleVolumeCoefficientType":{"$ref":"#/components/schemas/CoefficientType"},"MartingaleStepCoefficientType":{"$ref":"#/components/schemas/CoefficientType"},"DisableAfterDealsCountType":{"$ref":"#/components/schemas/CountType"},"AllowedDealsOnSamePair":{"$ref":"#/components/schemas/CountType"},"LeverageValueType":{"$ref":"#/components/schemas/IntegerPositiveType"},"MaxSafetyOrdersType":{"$ref":"#/components/schemas/IntegerZeroPositiveType"},"ActiveSafetyOrdersCountType":{"$ref":"#/components/schemas/IntegerZeroPositiveType"},"BotsShowLimitType":{"$ref":"#/components/schemas/IntegerZeroPositiveType"},"PerPageType":{"type":"integer","format":"int32","enum":[10,25,50,100],"default":10},"PageType":{"type":"integer","format":"int32","minimum":1,"default":1},"CloseDealsTimeoutType":{"description":"Close bot deals after given number of seconds. Must be greater than 60.\n","type":"integer","format":"int32","exclusiveMinimum":60},"DealStatusEnum":{"type":"string","description":"Values: created, base_order_placed, bought, cancelled, completed, failed, panic_sell_pending, panic_sell_order_placed, panic_sold, cancel_pending, stop_loss_pending, stop_loss_finished, stop_loss_order_placed, switched, switched_take_profit, ttp_activated, ttp_order_placed, liquidated, bought_safety_pending, bought_take_profit_pending, settled\n","enum":["created","base_order_placed","bought","cancelled","completed","failed","panic_sell_pending","panic_sell_order_placed","panic_sold","cancel_pending","stop_loss_pending","stop_loss_finished","stop_loss_order_placed","switched","switched_take_profit","ttp_activated","ttp_order_placed","liquidated","bought_safety_pending","bought_take_profit_pending","settled"],"examples":["failed"]},"LocalizedStatusEnum":{"type":"string","enum":["Created","Active"],"examples":["failed"]},"OrderVolumeEnum":{"type":"string","description":"Values: quote_currency, base_currency, percent, xbt\n","examples":["quote_currency"],"oneOf":[{"$ref":"#/components/schemas/ProfitCurrencyEnum"},{"enum":["percent","xbt"]}]},"PriceType":{"description":"Order price\n","type":"number","format":"double","minimum":0},"OrderVolumeType":{"description":"Order size\n","type":"number","format":"double","minimum":0,"examples":["0.001"]},"ProfitCurrencyEnum":{"type":"string","description":"Values: quote_currency, base_currency\n","examples":["quote_currency"],"enum":["quote_currency","base_currency"]},"TakeProfitEnum":{"type":"string","description":"Values: base, total\n","examples":["base"],"default":"total","enum":["base","total"]},"BotFormEnum":{"type":"string","description":"Param for a filter by bot form type (gordon/advanced)","enum":["gordon","advanced"]},"BotEnum":{"type":"string","description":"Values: [\"Bot::MultiBot\", \"Bot::SingleBot\", \"Bot::SwitchBot\"]\n","examples":["Bot::MultiBot"],"enum":["Bot::MultiBot","Bot::SingleBot","Bot::SwitchBot"]},"GridEnum":{"type":"string","description":"Grid Type","default":"arithmetic","enum":["geometric","arithmetic"]},"StopLossEnum":{"type":"string","examples":["stop_bot"],"enum":["stop_bot","stop_bot_and_buy"]},"StopLossActionEnum":{"type":"string","examples":["stop_bot"],"enum":["stop_bot","stop_bot_and_buy","stop_bot_and_sell","stop_bot_and_close_position"]},"StopLossDealsEnum":{"type":"string","examples":["stop_bot"],"enum":["stop_bot","stop_bot_and_close_position"]},"BotQueryEnum":{"type":"string","description":"simple or composite","examples":["simple"],"enum":["
[...]
